package manager;


import javafx.scene.image.Image;
import javafx.scene.image.ImageView;
import javafx.scene.text.Font;

public class ResourceManager {
	
	private static Font fontBig = null;
	private static Font fontSmall = null;
	
	private static ImageView addImage = null;
	private static ImageView backImage = null;
	private static ImageView editImage = null;
	private static ImageView lockImage = null;
	private static ImageView saveImage = null;
	private static ImageView unsavedImage = null;
	private static ImageView trashImage = null;
	
	
	public static void loadResources() {
		fontBig = Font.loadFont(ResourceManager.class.getResourceAsStream("/LiberationSerif-Regular.ttf"), 40);
		fontSmall = Font.loadFont(ResourceManager.class.getResourceAsStream("/LiberationSerif-Regular.ttf"), 17);
		
		addImage = new ImageView(new Image(ResourceManager.class.getResourceAsStream("/plus.png"), 32, 32, true, false));
		addImage.setFitWidth(32);
		addImage.setFitHeight(32);
		addImage.setPreserveRatio(true);
		
		backImage = new ImageView(new Image(ResourceManager.class.getResourceAsStream("/back.png"), 32, 32 ,true, false));
		editImage = new ImageView(new Image(ResourceManager.class.getResourceAsStream("/edit.png"),32 ,32, true, false));
		lockImage = new ImageView(new Image(ResourceManager.class.getResourceAsStream("/lock.png"), 32, 32, true, false));
		saveImage = new ImageView(new Image(ResourceManager.class.getResourceAsStream("/save.png"), 32, 32 ,true, false));
		unsavedImage = new ImageView(new Image(ResourceManager.class.getResourceAsStream("/unsaved.png"), 32, 32, true, false));
		
		trashImage = new ImageView(new Image(ResourceManager.class.getResourceAsStream("/trash.png"), 32, 32 ,true, false));
	}

	public static Font getFontBig() {
		return fontBig;
	}


	public static Font getFontSmall() {
		return fontSmall;
	}


	public static ImageView getAddImage() {
		return addImage;
	}
	
	public static ImageView getBackImage() {
		return backImage;
	}


	public static ImageView getEditImage() {
		return editImage;
	}


	public static ImageView getLockImage() {
		return lockImage;
	}



	public static ImageView getSaveImage() {
		return saveImage;
	}
	
	public static ImageView getSaveImageUnsaved() {
		return unsavedImage;
	}



	public static ImageView getTrashImage() {
		return trashImage;
	}



	



}